using System;

class HoldRef
{
    public object target;
    private string n;
    public HoldRef(string name) { n = name; }

    ~HoldRef()
    {
        Console.WriteLine("GC finalizing " + n);
    }
}

class App
{
    static void Main()
    {
        HoldRef first = new HoldRef("first");
        HoldRef second = new HoldRef("second");

        // Set up a circular reference
        first.target = second;
        second.target = first;

        // Let go of root references
        first = null;
        second = null;

        // GC
        GC.Collect();
        GC.WaitForPendingFinalizers();

        Console.WriteLine("Done GC");
        Console.ReadLine();
    }
}
